<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Teacher_Rating extends Controller_UserEnvi {
    
    public function action_edit()
    {
        $twig = Twig::factory('teacher/setRate');
        $twig->User = $this->UserInfo;
        $id = $this->request->param('id');
        $db = new Model_Teacher_Rating;
		// Шапка: модули и подмодули
		$discipline = $db->GetMapForDiscipline($this->UserInfo['TeacherID'], $id);
		$disciplineHandled = array();
		$maxRate = 0; $i = 0; $module = 0;
        foreach($discipline as $row)
        {
            if($row['ModuleID'] != $module)
            {
                $i++;
                $module = $row['ModuleID'];
            }
			if ($i == 1)
				$disciplineHandled['SubjectName'] = $row['SubjectName'];
            if(!isset($disciplineHandled[$i]['SubmodulesCount']))
            {
                $disciplineHandled[$i]['SubmodulesCount'] = 0;
                $disciplineHandled[$i]['MaxRate'] = 0;
            }
            $j = $disciplineHandled[$i]['SubmodulesCount'] += 1;
            $disciplineHandled[$i]['MaxRate'] += (int) $row['MaxRate'];
            $disciplineHandled[$i]['ModuleTitle'] = $row['ModuleName'];
			$disciplineHandled[$i][$j]['SubmoduleID'] = $row['SubmoduleID'];
            $disciplineHandled[$i][$j]['Title'] = $row['SubModuleName'];
            $disciplineHandled[$i][$j]['Description'] = $row['SubmoduleDescription'];
            $disciplineHandled[$i][$j]['MaxRate'] = (int) $row['MaxRate'];
            $maxRate += $row['MaxRate'];
        }
        $disciplineHandled['ModulesCount'] = $i;
        $disciplineHandled['MaxRate'] = (int) $maxRate; 
		$twig->headerRate = $disciplineHandled;
		// Студенты и баллы
		$students = $db->GetStudentsForDiscipline($this->UserInfo['TeacherID'], $id);
		$studentsHandled = array();
		$i = 0;
		foreach($students as $row) {
			$i++;
			$studentsHandled[$i]['StudentID'] = $row['StudentID'];
			$studentsHandled[$i]['LastName'] = $row['LastName'];
			$studentsHandled[$i]['FirstName'] = $row['FirstName'];
			$studentsHandled[$i]['SecondName'] = $row['SecondName'];
			$rate = $db->getMapForStudent($row['StudentID'], $id);
			$j = 0;
			foreach($rate as $r) {
				$j += 1;
				$studentsHandled[$i][$j]['SubmoduleID'] = $r['SubmoduleID'];
				$studentsHandled[$i][$j]['Rate'] = $r['Rate'];
			}
			$studentsHandled[$i]['RateCount'] = $j;
		}
		$twig->tableRate = $studentsHandled;
		
		$this->response->body($twig);
		//$this->response->body(var_dump($disciplineHandled));
		//$this->response->body(var_dump($studentsHandled));
    }
}
            